#!/bin/bash
# This script will take the ourput files of namd stmv run, which
# report days/ns performance data.  It uses the face that these output
# files are in the outputfiles directory and are called
# namdstnvXXXX.o, where XXXX is the number of cores (prepended with
# zeros), to generate a file PERFORMANCE.dat. This file will contains
# a record for each number of cores containing columns with cores,
# nsec/day, the error in nsec/day, the sec/step, the speedup and
# efficiency.
echo "#cores nsec/day (error)  sec/step  speedup  efficiency" > PERFORMANCE.dat
for CORES in 8 16 32 48 64 128 192 256 384 512 768 1024 1536 2048 4096; do
    ZCORES=$(printf "%04d" $CORES)
    grep Benchmark\ time outputfiles/namdstmv$ZCORES.o* | awk '{print $4, 1.0/$8, $6}' | awk 'BEGIN{p=0;s=0.0;s2=0.0;q=0}{p=$1;s=s+log($2);s2=s2+log($2)*log($2);q=q+$3}END{printf "%6d %8f %8f %8f %8.1f %8.2f\n",p,exp(s/NR),exp(s/NR)*sqrt((s2/NR-s*s/(NR*NR))/NR),q/NR,exp(s/NR)/(0.0057),exp(s/NR)/(0.045631/8)/p;}' >> PERFORMANCE.dat
done
# make a plot of the speed up using gnuplot
module load extras Xlibraries gnuplot
rm -f PERFORMANCE.eps
gnuplot namdstmv.gp
epstopdf PERFORMANCE.eps
#xpdf PERFORMANCE.pdf
